#include <SPI.h> // Required to use Ethernet
#include <Ethernet.h> // The Ethernet library includes the client
#include <Progmem.h> // Allows us to sacrifice flash for DRAM
#include <DHT.h>
#include <stdio.h>
#define DHT_PIN 2
DHT dht(DHT_PIN,DHT22);//DHT22 for my sensorRHT03-others in library
#define TIMEOUT 3000 //3 second timout
#define SPARKFUN_UPDATE_TIME 180000         //Update SparkFun data server every 60000 ms (1 minute).

unsigned long timer1 = 0;
unsigned long timer2 = 0;

byte mac[] = {0xDE, 0xAD, 0x07, 0x11, 0x32, 0x00};//put your own devices MAC address here
char server[] = "data.sparkfun.com";    // name address for data.sparkFun (using DNS)
// Set the static IP address to use if the DHCP fails to assign
IPAddress ip(192,168,0,178);  //This depends on your router its the address you put in
                              // the browser to see your own data while testing
EthernetClient client;

const String publicKey = "RMzp9ANyqzfjw4drzNnZ"; //Put your own key public here
const String privateKey = "####################"; //Put your own private key here
const byte NUM_FIELDS = 4;
const String fieldNames[NUM_FIELDS] = {"humidity" , "pressure2" , "temp" , "temp2"};
String fieldData[NUM_FIELDS];
const int triggerPin = 3;
const int lightPin = A0;
const int switchPin = 5;
String name = "Ether-anon";
boolean newName = true;

//Character array to hold results
char s[4];
//const int requestInterval = 20000;
long lastAttemptTime = 0; 
float humidity=0;
float temp=0;
long pressure2 = 0;
float temp2;
 // pins used for the connection with the sensor
// the others you need are controlled by the SPI library):
const int dataReadyPin = 7; 
const int chipSelectPin = 6;
double T,P,p0,a;
//float temp2 = 0.0;

long lastReadingTime = 0;

#include <SFE_BMP180.h>
#include <Wire.h>

// You will need to create an SFE_BMP180 object, here called "pressure":

SFE_BMP180 pressure;

#define ALTITUDE 750.0 // Altitude of My HQ in  meters


void setup()
{ Serial.begin(115200);
  SPI.begin();
  setupEthernet();
  dht.begin();
  Serial.println("all going");

  // Initialize the sensor (it is important to get calibration values stored on the device).

  if (pressure.begin())
    Serial.println("BMP180 init success");
  else
  {
    // Oops, something went wrong, this is usually a connection problem,
    // see the comments at the top of this sketch for the proper connections.

    Serial.println("BMP180 init fail\n\n");
    while(1); // Pause forever.
  }
   // Setup Input Pins:
  pinMode(triggerPin, INPUT_PULLUP);
  pinMode(switchPin, INPUT_PULLUP);
  pinMode(lightPin, INPUT_PULLUP);
 // initalize the  data ready and chip select pins:
  //pinMode(dataReadyPin, INPUT);
 // pinMode(chipSelectPin, OUTPUT);

 //Setup pressure and temp2
 //Sensor's memory register addresses:
const int PRESSURE = 0x1F;      //3 most significant bits of pressure
const int PRESSURE_LSB = 0x20;  //16 least significant bits of pressure
const int TEMPERATURE = 0x21;   //16 bit temperature reading

  //Configure SCP1000 for low noise configuration:
  writeRegister(0x02, 0x2D);
  writeRegister(0x01, 0x03);
  writeRegister(0x03, 0x02);
 // give the sensor and Ethernet shield time to set up:
  delay(1000);

  //Set the sensor to high resolution mode tp start readings:
  writeRegister(0x03, 0x0A);

 
  Serial.println(F("=========== Ready to Stream ==========="));
  Serial.println(F("Press the button (D3) to send an update"));
  Serial.println(F("Type your name (no spaces!), followed by '!' to update name"));
}

void loop()
{
char status;
  

  // Loop here getting pressure readings every 10 seconds.

  // If you want sea-level-compensated pressure, as used in weather reports,
  // you will need to know the altitude at which your measurements are taken.
  // We're using a constant called ALTITUDE in this sketch:
  
  //Serial.println();
  //Serial.print("provided altitude: ");
  //Serial.print(ALTITUDE,0);
 // Serial.print(" meters, ");
 // Serial.print(ALTITUDE*3.28084,0);
  //Serial.println(" feet");
  
  // If you want to measure altitude, and not pressure, you will instead need
  // to provide a known baseline pressure. This is shown at the end of the sketch.

  // You must first get a temperature measurement to perform a pressure reading.
  
  // Start a temperature measurement:
  // If request is successful, the number of ms to wait is returned.
  // If request is unsuccessful, 0 is returned.

  status = pressure.startTemperature();
  if (status != 0)
  {
    // Wait for the measurement to complete:
    delay(status);

    // Retrieve the completed temperature measurement:
    // Note that the measurement is stored in the variable T.
    // Function returns 1 if successful, 0 if failure.

    status = pressure.getTemperature(T);
    if (status != 0)
    {
      // Print out the measurement:
      //Serial.print("temperature: ");
     // Serial.print(T,2);
     // Serial.print(" deg C, ");
      //Serial.print((9.0/5.0)*T+32.0,2);
     // Serial.println(" deg F");
      
      // Start a pressure measurement:
      // The parameter is the oversampling setting, from 0 to 3 (highest res, longest wait).
      // If request is successful, the number of ms to wait is returned.
      // If request is unsuccessful, 0 is returned.

      status = pressure.startPressure(3);
      if (status != 0)
      {
        // Wait for the measurement to complete:
        delay(status);

        // Retrieve the completed pressure measurement:
        // Note that the measurement is stored in the variable P.
        // Note also that the function requires the previous temperature measurement (T).
        // (If temperature is stable, you can do one temperature measurement for a number of pressure measurements.)
        // Function returns 1 if successful, 0 if failure.

        status = pressure.getPressure(P,T);
        if (status != 0)
        {
          // Print out the measurement:
         // Serial.print("absolute pressure: ");
          //Serial.print(P,2);
          
          fieldData[1]=String(P,2);
          
          fieldData[3]=String(T,2);
         // Serial.print(" mb, ");
          //Serial.print(P*0.0295333727,2);
         // Serial.println(" inHg");
         
          // The pressure sensor returns abolute pressure, which varies with altitude.
          // To remove the effects of altitude, use the sealevel function and your current altitude.
          // This number is commonly used in weather reports.
          // Parameters: P = absolute pressure in mb, ALTITUDE = current altitude in m.
          // Result: p0 = sea-level compensated pressure in mb

         // p0 = pressure.sealevel(P,ALTITUDE); // we're at 1655 meters (Boulder, CO)
         // Serial.print("relative (sea-level) pressure: ");
        //  Serial.print(p0,2);
        //  Serial.print(" mb, ");
        //  Serial.print(p0*0.0295333727,2);
         // Serial.println(" inHg");

          // On the other hand, if you want to determine your altitude from the pressure reading,
          // use the altitude function along with a baseline pressure (sea-level or other).
          // Parameters: P = absolute pressure in mb, p0 = baseline pressure in mb.
          // Result: a = altitude in m.

         // a = pressure.altitude(P,p0);
        //  Serial.print("computed altitude: ");
        //  Serial.print(a,0);
        //  Serial.print(" meters, ");
        //  Serial.print(a*3.28084,0);
        //  Serial.println(" feet");
        }
        else Serial.println("error retrieving pressure measurement\n");
      }
      else Serial.println("error starting pressure measurement\n");
    }
    else Serial.println("error retrieving temperature measurement\n");
  }
  else Serial.println("error starting temperature measurement\n");

  delay(5000);  // Pause for 5 seconds

  
  //Update sparkfun data server every 60 seconds.
     // Convert each value to a string for our request to App Engine
  
  humidity = dht.readHumidity();
  temp = dht.readTemperature();  //temp = (temp*9/5) + 32 - 1; //To Farenheight calibrate here
  
  String temp_string = dtostrf(temp*100, 4, 0, s);
  String humidity_string = dtostrf(humidity*100, 4, 0, s);
  delay(200);
  fieldData[0]=String(humidity);
  fieldData[2]=String(temp);
  
  //get pressure and temp2
  if (millis() - lastReadingTime > 1000){
    // if there's a reading ready, read it:
    // don't do anything until the data ready pin is high:
    if (digitalRead(dataReadyPin) == HIGH) {
      getData();
      // timestamp the last time you got a reading:
      lastReadingTime = millis();
      
    }
 
  
  if(millis() > timer1 + SPARKFUN_UPDATE_TIME)
  {
    timer1 = millis(); //Update timer1 with the current time in miliseconds since startup.
     // Gather data:
    //fieldData[0] = String("To Come");//String(humidity);
    //fieldData[1] = String(pressure2);  
    //fieldData[2] = String("To Come");
    //fieldData[3] = String(temp2);
    delay(500);
    Serial.println("Posting by timer !");
    postData(); //Send data to sparkfun data server.
    Serial.println("Just after timer1\n");
   Serial.println(fieldData[0] );
   Serial.println(fieldData[1] );
   Serial.println(fieldData[2] );
   Serial.println(fieldData[3] );
    delay(500);
  }

    // If the trigger pin (3) goes low, send the data.
  if (!digitalRead(triggerPin))
  {
    // Gather data:
    //fieldData[0] = String("To Come");
    //fieldData[1] = String(pressure2);  
    //fieldData[2] = String("To Come");
    //fieldData[3] = String(temp2);
    delay(500);
    Serial.println("Posting by Trigger pin!");
    postData(); // the postData() function does all the work, 
                       // check it out below.
    Serial.println("Just after trigger\n");
    delay(500);
  }
  
  // Check for a new name input:
  if (Serial.available())
  {
    char c = Serial.read();
    if (c == '!')
    {
      newName = true;
      Serial.print("Your name is ");
      Serial.println(name);
    }
    else if (newName)
    {
      newName = false;
      name = "";
      name += c;
    }
    else
    {
      name += c;
    }
  }
}
}


